<template>
  <div>
    <form novalidate class="md-layout" @submit.prevent="validateUser">
      <md-card class="user-form md-layout-item md-size-30 md-small-size-100">
        <md-card-header>
          <div class="md-title">Register</div>
        </md-card-header>

        <md-card-content>
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('name')">
                <label for="first-name">Name and surname</label>
                <md-input
                  name="first-name"
                  id="first-name"
                  autocomplete="given-name"
                  v-model="form.name"
                  :disabled="sending"
                />
                <span class="md-error" v-if="!$v.form.name.required">Name is required</span>
                <span class="md-error" v-else-if="!$v.form.name.minlength">Invalid name</span>
              </md-field>
            </div>

            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('username')">
                <label for="last-name">Login name</label>
                <md-input
                  name="last-name"
                  id="last-name"
                  autocomplete="family-name"
                  v-model="form.username"
                  :disabled="sending"
                />
                <span class="md-error" v-if="!$v.form.username.required">The username is required</span>
                <span class="md-error" v-else-if="!$v.form.username.minlength">Invalid username</span>
              </md-field>
            </div>
          </div>

          <md-field :class="getValidationClass('email')">
            <label for="email">Email</label>
            <md-input
              type="email"
              name="email"
              id="email"
              autocomplete="email"
              v-model="form.email"
              :disabled="sending"
            />
            <span class="md-error" v-if="!$v.form.email.required">The email is required</span>
            <span class="md-error" v-else-if="!$v.form.email.email">Invalid email</span>
          </md-field>
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('password')">
                <label for="password">Password</label>
                <md-input
                  type="password"
                  name="password"
                  id="password"
                  autocomplete="password"
                  v-model="form.password"
                  :disabled="sending"
                />
                <span class="md-error" v-if="!$v.form.password.required">The password is required</span>
                <span class="md-error" v-else-if="!$v.form.password.password">Invalid password</span>
              </md-field>
            </div>
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('confirm_password')">
                <label for="confirm_password">Confirm password</label>
                <md-input
                  type="password"
                  name="confirm_password"
                  id="confirm_password"
                  autocomplete="password"
                  v-model="form.confirm_password"
                  :disabled="sending"
                />
                <span
                  class="md-error"
                  v-if="!$v.form.confirm_password.required"
                >The password is required</span>
                <span
                  class="md-error"
                  v-else-if="!$v.form.confirm_password.confirm_password"
                >Invalid password</span>
              </md-field>
            </div>
          </div>
        </md-card-content>

        <md-progress-bar md-mode="indeterminate" v-if="sending" />

        <md-card-actions>
          <md-button to="/login">Already have an account?</md-button>
          <md-button type="submit" class="md-primary" :disabled="sending">Create user</md-button>
        </md-card-actions>
      </md-card>

      <md-snackbar :md-active.sync="userSaved">
        The user {{ lastUser }} was created with success!
        <md-progress-spinner
          class="white-spinner"
          :md-diameter="25"
          :md-stroke="4"
          md-mode="determinate"
          :md-value="amount"
        ></md-progress-spinner>
      </md-snackbar>
    </form>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import { validationMixin } from "vuelidate";
import {
  required,
  email,
  minLength,
  maxLength
} from "vuelidate/lib/validators";

export default {
  name: "FormValidation",
  mixins: [validationMixin],
  data: () => ({
    amount: 0,
    form: {
      name: null,
      username: null,
      password: null,
      email: null,
      confirm_password: null
    },
    userSaved: false,
    sending: false,
    lastUser: null
  }),
  validations: {
    form: {
      name: {
        required,
        minLength: minLength(3)
      },
      username: {
        required,
        minLength: minLength(3),
        maxLength: maxLength(25)
      },
      password: {
        required,
        minLength: minLength(6),
        maxLength: maxLength(40)
      },
      confirm_password: {
        required,
        minLength: minLength(6),
        maxLength: maxLength(40)
      },
      email: {
        required,
        email,
        maxLength: maxLength(40)
      }
    }
  },
  methods: {
    ...mapActions(["register"]),

    getValidationClass(fieldName) {
      const field = this.$v.form[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    clearForm() {
      this.$v.$reset();
      this.form.name = null;
      this.form.username = null;
      this.form.password = null;
      this.form.confirm_password = null;
      this.form.email = null;
    },
    saveUser() {
      this.sending = true;
      let user = {
        username: this.form.username,
        password: this.form.password,
        confirm_password: this.form.confirm_password,
        email: this.form.email,
        name: this.form.name
      };
      this.register(user).then(res => {
        if (res.data.success) {
          window.setTimeout(() => {
            this.$router.push("login");
          }, 4000);

          let intervalIndicator = () =>
            window.setInterval(() => {
              this.amount = this.amount + 1;
            }, 150);

          intervalIndicator();

          window.setTimeout(() => {
            this.lastUser = `${this.form.name} ${this.form.username}`;
            this.userSaved = true;
            this.sending = false;
            this.amount = 0;
            this.clearForm();
            window.clearInterval(intervalIndicator);
          }, 1500);
        }
      });
    },
    validateUser() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.saveUser();
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.md-progress-bar {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
}
.user-form {
  margin-left: auto;
  margin-right: auto;
}
.md-snackbar {
  background-color: #3dc360;
}
</style>
